{ 010113-4.PAS                                                              }
{ 2001-01-13 programmeerimisolmpiaadi 4. lesande lahendus                 }
{    SAARED                                                                 }
{ Indrek Jentson                                                            }
{ Testitud: TP 6.0, FPC 0.99.10                                             }

{
4. SAARED				25 punkti	10 sekundit

he saareriigi asustus koosneb mitmel saarel laiali paiknevatest kladest.
Igal saarel on teed, mida mda pseb igast klast igasse teise samal
saarel olevasse klasse (kas otse vi lbi mne teise kla), kuid silla-
ehitamine on kohaliku rahva jaoks tundmatu kunst. Kirjutada programm, mis
selle riigi teedekaardi jrgi leiab asustatud saarte arvu.

Sisend. Tekstifaili SAARED.SIS esimesel real on kaks thikuga eraldatud
tisarvu -- klade arv N (1 <= N <= 100) ja teede arv M (1 <= M <= 1000).
Klad on thistatud numbritega 1..N. Jrgmisel M real on igahel kaks
thikuga eraldatud tisarvu -- he tee otstes olevate klade thised.

Vljund. Tekstifaili SAARED.VAL vljastada ks tisarv -- asustatud saarte
arv.
}

CONST
  MaxN = 100; { ==> vib kasutada lhedusmaatriksit }

VAR
  Teed : ARRAY[1..MaxN, 1..MaxN] OF INTEGER;
         { 0:tee puudub, -1:tee olemas, [x,x]=0:klas kimata }

  N, Saarte_Arv : INTEGER;

FUNCTION LOE_SISENDANDMED : BOOLEAN;
VAR
  SISENDFAIL : TEXT;
  M, A, B, I, J : INTEGER;
BEGIN
  ASSIGN(SISENDFAIL,'SAARED.SIS');
  {$I-}
  RESET(SISENDFAIL);
  {$I+}
  IF IORESULT = 0 THEN
    BEGIN
      { algvrtustame globaalsed muutujad }
      READ(SISENDFAIL, N, M);
      FOR I := 1 TO N DO
        FOR J := 1 TO N DO
          Teed[I,J] := 0;
      { loeme sisse teed }
      FOR I := 1 TO M DO
        BEGIN
          READ(SISENDFAIL, A, B);
          Teed[A,B] := -1;         { tee on lbitav mlemat pidi }
          Teed[B,A] := -1;
        END;
      CLOSE(SISENDFAIL);
      LOE_SISENDANDMED := TRUE;
    END
  ELSE
    LOE_SISENDANDMED := FALSE;
END;

PROCEDURE JALUTA(X : INTEGER);
VAR
  I : INTEGER;
BEGIN
  Teed[X,X] := Saarte_Arv; { mrgime, et selles klas oleme me kinud }
  FOR I := 1 TO N DO
    IF (I<>X) AND (Teed[X,I] <> 0) { leidub tee teise klla }
      AND (Teed[I,I] = 0)          { ja selles teises klas pole kidud }
    THEN JALUTA(I);
END;

PROCEDURE LEIA_SAARTE_ARV;
VAR
  I : INTEGER;
BEGIN
  Saarte_Arv := 0;
  FOR I := 1 TO N DO
    IF Teed[I,I] = 0 THEN { selles klas pole kidud ==> leidsime uue saare }
      BEGIN
        INC(Saarte_Arv);
        JALUTA(I);        { vaatame klasid sellel saarel }
      END;
END;

PROCEDURE VASTUS;
VAR VASTUSFAIL : TEXT;
BEGIN
  ASSIGN(VASTUSFAIL,'SAARED.VAL');
  {$I-}
  REWRITE(VASTUSFAIL);
  {$I+}
  IF IORESULT = 0 THEN
    BEGIN
      WRITELN(VASTUSFAIL,Saarte_Arv);
      CLOSE(VASTUSFAIL);
    END;
END;

BEGIN
  IF LOE_SISENDANDMED THEN
    LEIA_SAARTE_ARV;
  VASTUS;
END.