{ kontroll.pas                                                              }
{ 2001-01-13 programmeerimisolmpiaadi 5. lesande testija                  }
{    VALIMISED                                                              }
{ Ahto Truu                                                                 }

{$I-}

const
   max = 1000;                               { maksimaalne valijameeste arv }

var
   f : text;
   n : integer;                                            { osariikide arv }
   m : integer;                                          { valijameeste arv }
   a : array [0..max] of integer;    { a[x] - x valijamehega osariikide arv }
   s : array [0..max] of boolean;        { s[x] - kas summa s on saavutatav }
   v : boolean;                       { kas president saab kindlalt valitud }
   i, j, x, y : integer;
   i1, i2 : integer;
   t : string;

begin
   if paramcount <> 2 then begin
      writeln ('Sntaks on: ', paramstr (0), ' sisendfail vljundfail');
      halt (1);
   end;

   { loeme sisendandmed ja leiame saavutatavad summad }
   assign (f, paramstr (1)); reset (f);
   if ioresult > 0 then begin
      writeln ('Viga faili ', paramstr (1), ' avamisel');
      halt (1);
   end;

   readln (f, n);
   if ioresult > 0 then begin
      writeln ('Viga faili ', paramstr (1), ' lugemisel');
      halt (1);
   end;

   m := 0;
   for i := 0 to max do begin
      a[i] := 0;
      s[i] := false;
   end;
   s[0] := true;

   for i := 1 to n do begin
      read (f, x);
      if ioresult > 0 then begin
         writeln ('Viga faili ', paramstr (1), ' lugemisel');
         halt (1);
      end;

      m := m + x;
      a[x] := a[x] + 1;
      for j := m downto 0 do
         if s[j] and (j + x <= max) then
            if not s[j + x] then
               s[j + x] := true;
   end;

   close (f);
   if ioresult > 0 then begin
      writeln ('Viga faili ', paramstr (1), ' lugemisel');
      halt (1);
   end;

   { kas pool valijameeste arvust on saavutatav summa? }
   if (m mod 2 = 1) then
      v := true
   else
      v := not s[m div 2];

   { kui president saab valitud, leiame hlte vahe }
   if v then begin
      i1 := m div 2;
      while (i1 > 0) and (not s[i1]) do
         i1 := i1 - 1;
      i2 := m div 2 + 1;
      while (i2 < m) and (not s[i2]) do
         i2 := i2 + 1;
      { kontrolltingimus: i1 + i2 = m }
      if i1 + i2 <> m then begin
         writeln ('Sisemine vastuolu testimisprogrammis');
         halt (1);
      end;
      x := i2 - i1;
      { kontrolltingimus: x > 0 }
      if x = 0 then begin
         writeln ('Sisemine vastuolu testimisprogrammis');
         halt (1);
      end;
   end;

   { loeme vistleja vastuse }
   assign (f, paramstr (2)); reset (f);
   if ioresult > 0 then begin
      writeln ('Viga faili ', paramstr (2), ' avamisel');
      halt (1);
   end;

   readln (f, t);
   if ioresult > 0 then begin
      writeln ('Viga faili ', paramstr (2), ' lugemisel');
      halt (1);
   end;

   if v then begin
      if (t = 'JAH') then begin
         writeln ('Vastus JAH ige');
      end else begin
         writeln ('*** Vale vastus ', t, ' faili ', paramstr (2), ' 1. real');
         writeln ('Peaks olema JAH');
      end;

      { jtkame kontrollimist mlemal juhul, tegu vis olla kirjaveaga }
      readln (f, y, t);
      if ioresult > 0 then begin
         writeln ('Viga faili ', paramstr (2), ' lugemisel');
         halt (1);
      end;

      if x = y then begin
         writeln ('Hlte vahe ', y, ' ige');
      end else begin
         writeln ('*** Vale vastus ', y, ' ', t, ' faili ', paramstr (2), ' 2. real');
         writeln ('Peaks olema ', x);
      end;
   end else begin
      if (t = 'EI') then begin
         writeln ('Vastus EI ige');
      end else begin
         writeln ('*** Vale vastus ', t, ' faili ', paramstr (2), ' 1. real');
         writeln ('Peaks olema EI');
      end;

      { jtkame kontrollimist mlemal juhul, tegu vis olla kirjaveaga }
      x := 0;
      while not seekeoln (f) do begin
         read (f, y);
         if ioresult > 0 then begin
            writeln ('Viga faili ', paramstr (2), ' lugemisel');
            halt (1);
         end;

         if (y < 0) or (y > max) or (a[y] = 0) then begin
            writeln ('Lubamatu valijameeste arv ', y, ' faili ', paramstr (2), ' 2. real');
            halt (1);
         end;
         a[y] := a[y] - 1;
         x := x + y;
      end;

      if x = m div 2 then begin
         writeln ('Hlte summa ', x, ' ige');
      end else begin
         writeln ('*** Vale hlte summa ', x, ' faili ', paramstr (2), ' 2. real');
         writeln ('Peaks olema ', m div 2);
      end;
   end;

   close (f);
   if ioresult > 0 then begin
      writeln ('Viga faili ', paramstr (2), ' lugemisel');
      halt (1);
   end;
end.