{ 010113-5.PAS                                                              }
{ 2001-01-13 programmeerimisolmpiaadi 5. lesande lahendus                 }
{    VALIMISED                                                              }
{ Inga Petuhhov                                                             }
{ Testitud: TP 6.0, FPC 0.99.10                                             }

{
lesande lahendamiseks tuleb leida, kas valijameeste arvudest on saavutatav
summa, mis on tpselt pool valijameeste koguarvust. heks vimaluseks oleks
kasutada sellise summa leidmiseks tislbivaatuse algoritmi, kuid suurema
osariikide arvu puhul, eriti kui hled pooleks ei jagune, osutub see liiga
aeglaseks. Tegemist on eksponentsiaalse keerukusega.

Seega on soodsam kasutada lainealgoritmi, mille puhul on keerukuseks n^2.
Kigepealt moodustame kikvimalikud summad. Selleks vtame kasutusele
1001 elemendise massiivi tisarvudest (indeksid 0..1000) ning selle
i-ndasse lahtrisse mrgime, kas summa i on moodustatav. Kui jrjest
kigi osariikide valijameeste arvud on lbivaadatud, on massiivis kirjas
kik moodustatavad summad.
he laine moodustab:
- osariigi valijameeste arvu lugemine sisendfailist
- selle arvu liitmine juurde kigile seni moodustunud summadele, selleks
  on programmis tskkel, mis algab seni leitud suurima summa juurest ja
  liigub 0-ni.
- kui liitmise tulemusena on tekkinud uus, seningemata summa, siis
  mrgitakse see uus summa ra summade massiivis, kui aga selline
  summa on juba olemas, ei muudeta massiivis midagi.
Laineid tehakse nii palju kui on osariike (maksimaalselt 1000).

Summade massiiv algvrtustatakse niteprogrammis -1-dega, kuid selleks
vib valida ka mne muu arvu, mis summana kunagi saavutatav pole. Erandiks
on element indeksiga 0, kuhu kirjutatakse 0, sest kuni pole htegi arvu,
on ainsaks saavutatavaks summaks 0.

Kuna ei piisa 'JAH'/'EI' vastusest, peab olema vimalik iga moodustuva summa
kohta kindlaks mrata, millistest liidetavatest ta saadi. Seega ei saa
massiivi kirjutada lihtsalt jah vi ei, vaid iga moodustatava summa kohale
pannakse massiivi kirja see summa, millest ta saadi.

Esimese laine alustamisel on 0 vaid 0-ndas positsioonis. Failist loetakse
esimene valijameeste arv (nit. 10). Liidetakse 0+10=10 ja massiivi 10-dasse
positsiooni kirjutatakse 0, sest uue summa 10 moodustamiseks kasutati summat
0.

Kui kik valijamehed on failist loetud ja kik vimalikud summad teada saadud
(need on need, mille kohal massiivis enam -1 pole), tehakse kindlaks, kas
summa, mis oleks tpselt pool valijameeste arvust, on saavutatav. Kui ta on,
siis kirjutatakse vljundfaili 'EI' ning leitakse summa moodustanud liidetavad
Vastasel juhul on vastuseks 'JAH', mis faili kirjutatakse ning leitakse
lhim moodustatav summa, mille jrgi saab vhima hlte vahe vlja arvutada.
}

program valimised;
const maxmehi=1000;
      sisendfail='valim.sis';
      valjundfail='valim.val';
type summadetyyp=array[0..maxmehi] of integer;
var summad: summadetyyp;  {massiiv voimalike summade hoidmiseks}
    f: text;              {sisend- ja valjundfaili muutuja}
    osariike: integer;    {failist loetav osariikide arv}
    valijamehi: integer;  {failist loetav uhe osariigi valijameeste arv}
    mehikokku: integer;   {arvutatav valijameeste koguarv}
    jarg: integer;        {abimuutuja summat moodustavate arvude leidmiseks vi vhima vahe jaoks (rohkem ilu mttes)}
    pooleks: integer;     {valijameeste arv pooleks}
    i, j: integer;        {tsklimuutujad}
begin
     writeln('Informaatika olmpiaadi koolivoor 2001 a.');
     writeln('5. lesande - Presidendi valimine nidislahendus');
     writeln('Idee: A. Truu, teostus: I. Petuhhov,');
     for i:=1 to maxmehi do               {Algvrtustamised}
         summad[i]:=-1;
     summad[0]:=0;
     mehikokku:=0;
     Assign(f,sisendfail);                {Faili avamine}
     Reset(f);
     readln(f,osariike);
     for i:=1 to osariike do              {Tskkel kigi valijameeste arvude failist lugemiseks}
     begin
          read(f,valijamehi);
          for j:=mehikokku downto 0 do    {Vaadatakse lbi moodustunud summad}
          begin
               if summad[j]<>-1 then      {Kui summa j on juba olemas, siis ...}
                  if summad[j+valijamehi]=-1 then {moodustame sellest uue summa ja kui sellist veel pole}
                     summad[j+valijamehi]:=j;  {mrgime uue summa ra}
          end;
          mehikokku:=mehikokku+valijamehi;
     end;
     Close(f);
     pooleks:=mehikokku div 2;            {Algab tulemuste vljastamine}
     Assign(f,valjundfail);
     Rewrite(f);
     jarg:=pooleks;
     if (not odd(mehikokku)) and (summad[pooleks]<>-1) then
     begin                            {Kui haaled saavad minna pooleks, leiame kes need olid}
          writeln(f,'EI');
          while summad[jarg]>0 do     {Alustades poolest valijameeste arvust leiame liidetavad, mis sellise summa moodustasid}
          begin
               write(f,jarg-summad[jarg],' ');
               jarg:=summad[jarg];
          end;
          writeln(f,jarg);
     end
     else                             {Hled ei saa pooleks jaguneda}
     begin
          writeln(f,'JAH');
          while summad[jarg]=-1 do    {Leiame lhima saavutatava summa poolele valijameeste arvule}
                jarg:=jarg-1;
          writeln(f,mehikokku-2*jarg);
     end;
     Close(f);
end.